
#import <UIKit/UIKit.h>
#import "ACShowController.h"
#import "ACWebLinkController.h"
#import "ACWebSearchHandler.h"

@interface ACWebShowController : ACShowController <UIWebViewDelegate> {
   UIWebView *webView;
   NSMutableArray *linkControllerChain;
   BOOL searchable;
   ACWebSearchHandler *searchHandler;
   UISearchBar *searchBar;   
}

@property (nonatomic, retain) UIWebView *webView;
@property (nonatomic, retain) ACWebSearchHandler *searchHandler;
@property (nonatomic, retain) UISearchBar *searchBar;
@property (nonatomic, retain) NSMutableArray *linkControllerChain;

- (NSString *) toHTML;
- (void) reloadWebView;
- (void)addLinkController:(id <ACWebLinkController>)controller;

- (id) initSearchable: (BOOL) searchable;

@end
